// WWlabFunction.cpp: implementation of the CWWlabFunction class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "WWlabFunction.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#pragma comment(lib,"MP417.lib")

#include "MP417.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CWWlabFunction::CWWlabFunction()
{

}

CWWlabFunction::~CWWlabFunction()
{

}

//********************************豸**********************************************

HANDLE CWWlabFunction::WWlab_OpenDevice(__int32 num)
{
	HANDLE hDevice;	
	
	hDevice=MP417_OpenDevice(num);

    return hDevice;
}


__int32 CWWlabFunction::WWlab_CloseDevice(HANDLE hDevice)
{
	
	return MP417_CloseDevice(hDevice);

}

//********************************EEPROM**********************************************

#define eep_rwlen 32

__int32 CWWlabFunction::WWlab_EEPROM_Write(HANDLE hDevice, unsigned char *wbuf)
{
	return MP417_EEPROM_Write(hDevice, wbuf);
}
    

__int32 CWWlabFunction::WWlab_EEPROM_Read(HANDLE hDevice, unsigned char *rbuf)
{
	
	return MP417_EEPROM_Read(hDevice,rbuf);
}

__int32 CWWlabFunction::WWlab_EEPROM_S_Write(HANDLE hDevice, unsigned char *wbuf)
{
	

	/*__int32 adr;
	__int32 tbuf[eep_rwlen];
	__int32 i=0;
	
	adr=0x1f00;
	
	for(i=0;i<eep_rwlen;i++)
		tbuf[i]=((unsigned char)wbuf[i]) & 0xff;

	return MP417_EEPROM_CWR(hDevice, adr,eep_rwlen,tbuf);*/

    return	MP417_EEPROM_S_Write(hDevice,wbuf);
}
    

__int32 CWWlabFunction::WWlab_EEPROM_S_Read(HANDLE hDevice, unsigned char *rbuf)
{
	/*__int32 adr;
	__int32 tbuf[eep_rwlen];
	__int32 i=0;
	
	adr=0x1f00;
	
	__int32 j=MP417_EEPROM_CRD(hDevice,adr,eep_rwlen,tbuf);

	for(i=0;i<eep_rwlen;i++)
		rbuf[i]=((unsigned char)(tbuf[i]) & 0xff);

    	
	return j;*/
	return MP417_EEPROM_S_Read(hDevice,rbuf);
}

//********************************AD**********************************************

//ѯ
__int32 CWWlabFunction::WWlab_AD_Cal(HANDLE hDevice)
{
	return MP417_CAL(hDevice);
}


__int32 CWWlabFunction::WWlab_AD(HANDLE hDevice,__int32 ch,__int32 gain,__int32 sidi,__int32 naver)
{

  return MP417_AD(hDevice,ch,gain,sidi,naver);

}

//

__int32 CWWlabFunction::WWlab_TAD(HANDLE hDevice,__int32 stch,__int32 endch,__int32 gain,__int32 sidi,__int32 tdata)
{

   return MP417_TAD(hDevice,stch,endch, gain, sidi,tdata);

}

__int32 CWWlabFunction::WWlab_TAD_Read(HANDLE hDevice,__int32 *rdata,__int32 length)
{
	return MP417_TAD_Read(hDevice,rdata,length);
}


__int32 CWWlabFunction::WWlab_TAD_Poll(HANDLE hDevice)
{
	
	return MP417_TAD_Poll(hDevice);

}

__int32 CWWlabFunction::WWlab_TAD_Stop(HANDLE hDevice)
{
	return MP417_TAD_Stop(hDevice);
}

double CWWlabFunction::WWlab_ADV(__int32 adg,__int32 addata)
{
	return MP417_ADV(adg,addata);
}

//********************************DIO**********************************************

__int32 CWWlabFunction::WWlab_DO(HANDLE hDevice, __int32 dodata)
{
	return  MP417_DO(hDevice,dodata);
}


__int32 CWWlabFunction::WWlab_DI(HANDLE hDevice)
{
	
	return MP417_DI(hDevice);
}


//********************************DA**********************************************

/*long CWWlabFunction::WWlab_DA_Mode(HANDLE hDevice, long dag0,long dag1)
{
	return  MP417_DA_Mode(hDevice,dag0,dag1);
}
*/

/*long CWWlabFunction::WWlab_DA(HANDLE hDevice,__int32 ch,__int32 dg,__int32 data)
{
	
	return MP417_DA(hDevice,ch,dg,data);
}

long CWWlabFunction::WWlab_DA_INI(HANDLE hDevice)
{
	
	return MP417_DA_INI(hDevice);
}
*/
//******************************************************************************

__int32 CWWlabFunction::WWlab_CNT_Run(HANDLE hDevice, __int32 cntch, __int32 cdata)
{
	return MP417_CNT_Run(hDevice,cntch,cdata);
}


__int32 CWWlabFunction::WWlab_CNT_Read(HANDLE hDevice, __int32 cntch,__int32 *cdata, __int32 *tdata)
{
	
	return MP417_CNT_Read(hDevice,cntch,cdata,tdata);

}
	

//********************************庯**********************************************

__int32 CWWlabFunction::WWlab_PRun(HANDLE hDevice,__int32 pch, __int32 pmode,__int32 pdata0, __int32 pdata1)
{
	return MP417_PRun(hDevice,pch,pmode,pdata0,pdata1);
}


__int32 CWWlabFunction::WWlab_PState(HANDLE hDevice,__int32 pch)
{
	
	return MP417_PState(hDevice,pch);

}

__int32 CWWlabFunction::WWlab_PEnd(HANDLE hDevice,__int32 pch)
{
	return MP417_PEnd(hDevice,pch);
}

__int32 CWWlabFunction::WWlab_PSetData(HANDLE hDevice,__int32 pch,__int32 pdata0,__int32 pdata1)
{
	return MP417_PSetData(hDevice,pch,pdata0,pdata1);
}

//********************************庯**********************************************

/*__int32 CWWlabFunction::WWlab_inb(HANDLE hDevice,__int32 adr)
{
	
	return  MP417_inb(hDevice,adr);
}


__int32 CWWlabFunction::WWlab_outb(HANDLE hDevice,__int32 adr,__int32 data)
{
	
	return MP417_outb(hDevice,adr,data);
}
*/