// WWlabFunction.h: interface for the CWWlabFunction class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WWLABFUNCTION_H__CF6FFF9D_3ABD_4E7C_8458_2636767C69CF__INCLUDED_)
#define AFX_WWLABFUNCTION_H__CF6FFF9D_3ABD_4E7C_8458_2636767C69CF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CWWlabFunction  
{
public:

	
	//忨̬⺯
	HANDLE WWlab_OpenDevice(__int32 num);             //򿪾
	__int32 WWlab_CloseDevice(HANDLE hDevice);        //رվ

	//EEprom
	__int32 WWlab_EEPROM_Write(HANDLE hDevice, unsigned char *wbuf);
	__int32 WWlab_EEPROM_Read(HANDLE hDevice, unsigned char *rbuf);

	__int32 WWlab_EEPROM_S_Write(HANDLE hDevice, unsigned char *wbuf);
	__int32 WWlab_EEPROM_S_Read(HANDLE hDevice, unsigned char *rbuf);
	
	//ADѯ
	
	__int32  WWlab_AD(HANDLE hDevice,__int32 adch,__int32 adg,__int32 sidi,__int32 naver);
    __int32 WWlab_AD_Cal(HANDLE hDevice);
	
	//ADɼ
	
	__int32 WWlab_TAD_Stop(HANDLE hDevice);
	
	__int32  WWlab_TAD(HANDLE hDevice,__int32 stch,__int32 endch,__int32 adg,__int32 sidi,__int32 tdata);
	
	__int32  WWlab_TAD_Read(HANDLE hDevice,__int32 *addata,__int32 rdlen);
	
	__int32  WWlab_TAD_Poll(HANDLE hDevice);

	double  WWlab_ADV(__int32 adg,__int32 addata);


	//DIO
	__int32 WWlab_DO(HANDLE hDevice, __int32 dodata);
	__int32 WWlab_DI(HANDLE hDevice);

	//DA
	//long WWlab_DA_Mode(HANDLE hDevice, long dag0,long dag1);
	//long WWlab_DA(HANDLE hDevice,__int32 dach,__int32 dg,__int32 data);
	//long WWlab_DA_INI(HANDLE hDevice);

	
	//ʱ
	__int32 WWlab_CNT_Run(HANDLE hDevice, __int32 cntch, __int32 cdata);
	__int32 WWlab_CNT_Read(HANDLE hDevice, __int32 cntch,__int32 *cdata, __int32 *tdata);


	//庯
	__int32 WWlab_PRun(HANDLE hDevice,__int32 pch, __int32 pmode,__int32 pdata0, __int32 pdata1);
	__int32 WWlab_PState(HANDLE hDevice,__int32 pch);
	__int32 WWlab_PEnd(HANDLE hDevice,__int32 pch);
    __int32 WWlab_PSetData(HANDLE hDevice,__int32 pch,__int32 pdata0, __int32 pdata1);
	
	//д
//	long  WWlab_outb(HANDLE hDevice,long adr,long data);
//	long  WWlab_inb(HANDLE hDevice,long adr);

	
	
	CWWlabFunction();
	virtual ~CWWlabFunction();

};

#endif // !defined(AFX_WWLABFUNCTION_H__CF6FFF9D_3ABD_4E7C_8458_2636767C69CF__INCLUDED_)
