// WWlabMFCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WWlabMFC.h"
#include "WWlabMFCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "WWlabFunction.h"
CWWlabFunction Func;
HANDLE hDevice;

#define cnt0_ini 10000   //set ini cnt data


__int32 addata[1000000];   //data buffer for AD

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWWlabMFCDlg dialog

CWWlabMFCDlg::CWWlabMFCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWWlabMFCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWWlabMFCDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWWlabMFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWWlabMFCDlg)
	DDX_Control(pDX, IDC_LIST1, m_List);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWWlabMFCDlg, CDialog)
	//{{AFX_MSG_MAP(CWWlabMFCDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_BUTTON_TAD, OnButtonTad)
	ON_BN_CLICKED(IDC_BUTTON_StopAD, OnBUTTONStopAD)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_DO, OnButtonDo)
	ON_BN_CLICKED(IDC_BUTTON_DI, OnButtonDi)
	ON_BN_CLICKED(IDC_BUTTON_AD, OnButtonAd)
	ON_BN_CLICKED(IDC_BUTTON_CNT, OnButtonCnt)
	ON_BN_CLICKED(IDC_BUTTON_CNTR, OnButtonCntr)
	ON_BN_CLICKED(IDC_BUTTON_DA, OnButtonDa)
	ON_BN_CLICKED(IDC_BUTTON_Plus, OnBUTTONPlus)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWWlabMFCDlg message handlers

BOOL CWWlabMFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWWlabMFCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWWlabMFCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWWlabMFCDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

int CWWlabMFCDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	hDevice=Func.WWlab_OpenDevice(0);
	
	if(hDevice==INVALID_HANDLE_VALUE)
	{
		AfxMessageBox("error open MP417 Device!");
		Beep(1000,300);
		exit(0);
	}
	
	return 0;
}

void CWWlabMFCDlg::OnButtonTad() 
{
	// TODO: Add your control notification handler code here
	stch=0;
	endch=15;
	gain=1;//-5-+5V
	sidi=0; //must be 0
	timer=1000;
	
	//--------------------------------open a file to write data -----------------------------------------------------
	//open file and get file name
	
	CFileDialog dlg(FALSE,"C:\\",NULL,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"ļ(*.dat)|*.dat||",this);
	
	if (dlg.DoModal() == IDCANCEL)
	{
        MessageBox("Not set File Name, program not run!",NULL,MB_OK);
		return;
	}
	
	m_filename=dlg.GetFileName();
	
	
	if(!mfp.Open(m_filename, CFile::modeCreate | CFile::modeReadWrite| CFile::typeBinary ))
	{
		MessageBox("Error Open file",NULL,MB_OK);
		return;
	}
    //end file
	
	
	//cal AD
	Func.WWlab_AD_Cal(hDevice);
	
	tad_run=false; //set ad not run sign
	
	//creat timer
	SetTimer(1,200,NULL);
	
	//run AD
    Func.WWlab_TAD(hDevice,stch,endch,gain,sidi,timer);
	
	//set sign
	tad_run=true;
	tad_saml=0; //total sam length
	
}

void CWWlabMFCDlg::OnBUTTONStopAD() 
{
	// TODO: Add your control notification handler code here
	Func.WWlab_TAD_Stop(hDevice); //stop ad
	
	KillTimer(1);
	
}

void CWWlabMFCDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default

	   if(nIDEvent==1)
	   {
		   //tad timer
		   if(tad_run) //if ad run
		   {
			   
			   long readlen;
			   int i=0;
			   
#define min_adreadlen 50   //min read ad data length, can't be too small, for write speed!!!
			   
			   //poll ad data can be read
			   readlen=Func.WWlab_TAD_Poll(hDevice);
			   
			   if(readlen<0)
			   {
				   ///ad fifo full
				   
				   Func.WWlab_TAD_Stop(hDevice); //stop ad
				   Beep(1000,200);
				   AfxMessageBox("AD Over Flow.....");
				   
			   }
			   
			   if(readlen>10000)  //read length > buffer length
			   {
				   readlen=10000;
				   
			   }
			   
			   if(readlen<min_adreadlen)
				   return;  //not write data and dis
			   
			   
			   //read data , length=ad channel number * N
			   int adchnum=endch-stch+1;  
			   readlen=(readlen/adchnum)*adchnum;
			   
			   //read data 
			   
			   Func.WWlab_TAD_Read(hDevice,addata,readlen);
			   
			   //set total read  length
			   tad_saml+=readlen;
			   
			   //write to file
			   //as 1 data =32bit or  4byte, so write length=4*readlen
			   mfp.WriteHuge(addata,readlen*4);
			   
			   //dis firt group ad data
			   CString aa;
			   
			   m_List.ResetContent();//clr screen
			   
			   //dis total length of sam
			   aa.Format("TAD  State........");
			   m_List.InsertString(-1,aa);
			   aa.Format("total sam length:%dK,  File Length:%d KByte",tad_saml/1024,tad_saml/1024*4);
			   m_List.InsertString(-1,aa);
			   
			   //dis 1st group ad data
			   for(i=stch;i<=endch;i++)
			   {
				   aa.Format("CH:%2d  Data:%5d",i,addata[i-stch]);
				   m_List.InsertString(-1,aa);
			   }
			   
			   
			   
		   }
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CWWlabMFCDlg::OnButtonAd() 
{
	// TODO: Add your control notification handler code here
	__int32 ch=0;
	__int32 gain=1;//-10-+10V
	__int32 sidi=0; //must be 0
	__int32 naver=1;
	
	__int32 i;
    
	
	for(i=0;i<16;i++)
	{
		//sam ad
		ch=i;
		addata[i]=Func.WWlab_AD(hDevice,ch,gain,sidi,naver);
	}
	
    //display ad data and voltage
    m_List.ResetContent(); //clear screen
	
	double v;
	CString aa;
	
	for(i=0;i<16;i++)
	{
        //convert data to voltage
		v=Func.WWlab_ADV(gain,addata[i]);
        aa.Format("CH%2d   Data:%5d   V=%6.2fmV",i,addata[i],v);
       	m_List.InsertString(-1,aa);
		
	}
	
}


void CWWlabMFCDlg::OnButtonDo() 
{
	// TODO: Add your control notification handler code here
	__int32 i=0x55aa; //set DO=55aa
    CString aa;
	
	Func.WWlab_PEnd(hDevice,0);
	Func.WWlab_PEnd(hDevice,1);
	
	Func.WWlab_PEnd(hDevice,0);
	Func.WWlab_PEnd(hDevice,1);
	aa.Format("Set DO:%XH",i);
	m_List.InsertString(-1,aa);
	
	Func.WWlab_DO(hDevice,i);
	
}

void CWWlabMFCDlg::OnButtonDi() 
{
	// TODO: Add your control notification handler code here
	CString aa;
    __int32 i=Func.WWlab_DI(hDevice);
	aa.Format("Read DI:%XH",i);
	m_List.InsertString(-1,aa);
	
}


void CWWlabMFCDlg::OnButtonCnt() 
{
	// TODO: Add your control notification handler code here
	__int32 i=cnt0_ini;
	CString aa;
	
	m_List.ResetContent();
	
    Func.WWlab_CNT_Run(hDevice,0, i);  //set cht0 run
	aa.Format("CNT0 Run , Initial data:%d",i);
	m_List.InsertString(-1,aa);

	
}

void CWWlabMFCDlg::OnButtonCntr() 
{
	// TODO: Add your control notification handler code here
	__int32 i,j;
	__int32 csign;
	CString aa;
	
    csign=Func.WWlab_CNT_Read(hDevice,0, &i,&j);  //set cht0 run
	aa.Format("CNT0: read data:%d  cnt:%d  timer:%d",i,cnt0_ini-i,j);
	m_List.InsertString(-1,aa);
	
	
	if(csign==1) //over and time gap data is ok!
	{
        aa.Format("-------cnt over and time gap is ok!------------");
        m_List.InsertString(-1,aa);
		aa.Format("tdata=%d    time=%8.1fuS",j,(double)j*0.1);
        m_List.InsertString(-1,aa);
	}
	
	 m_List.UpdateWindow();
	
}

void CWWlabMFCDlg::OnButtonDa() 
{
	// TODO: Add your control notification handler code here
	/*m_List.ResetContent();
	CString aa;
    Func.WWlab_DA_INI(hDevice);  //set cht0 run
	Func.WWlab_DA(hDevice,0,1,4095);//10V
	Func.WWlab_DA(hDevice,1,2,0);//-5-+5V
	aa.Format("DA ch0 10V,DA ch1 -5V");
	m_List.InsertString(-1,aa);
*/
	
}

void CWWlabMFCDlg::OnBUTTONPlus() 
{
	// TODO: Add your control notification handler code here
	m_List.ResetContent();
	CString aa;
    Func.WWlab_PRun(hDevice,0,0,10000,5000);  //set cht0 run
    Func.WWlab_PRun(hDevice,1,2,10000,5000);  //set cht0 run
	
	aa.Format(" ch0 1KHZ, ch1 5001KHZ");
	m_List.InsertString(-1,aa);
	
}
